;-- TIME_STAMP   2018-12-28 03:36:20   v 0.1

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region ;************ Includes ************
#include-once
#include <Memory.au3>
;~ #include <_ComputeCrc32.au3> ; wenn sich die Datei in deinem IncludeDir befindet
#include "_ComputeCrc32.au3" ; wenn sich die Datei im ScriptDir befindet
#EndRegion ;************ Includes ************

_ComputeCrc32_Demo()

Func _ComputeCrc32_Demo()
	Local $vRet, $vData, $tStruct, $pMem, $iLen

	; Calculates the CRC32 checksum of a file (file not found or empty)
	$vRet = _ComputeCrc32(@HomeDrive & '\$WINRE_BACKUP_PARTITION.MARKER') ; file is empty
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   _ComputeCrc32(@HomeDrive & '\$WINRE_BACKUP_PARTITION.MARKER') : $vRet --> " & $vRet & @CRLF & _
		"!@ " & @TAB & "#Error: " & @error & @TAB & "#Extended: " & @extended & @CRLF)

	; Calculates the CRC32 checksum of a file
	$vRet = _ComputeCrc32('C:\Windows\System32\cmd.exe')
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   _ComputeCrc32('C:\Windows\System32\cmd.exe') (FileName)       : $vRet --> " & $vRet & @CRLF & _
		"!@ " & @TAB & "#Error: " & @error & @TAB & "#Extended: " & @extended & @CRLF)

	; Calculates the CRC32 checksum of a string
	$vRet = _ComputeCrc32('C:\Windows\System32\cmd.exe', -1, 2)
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   _ComputeCrc32('C:\Windows\System32\cmd.exe', -1, 2) (String ) : $vRet --> " & $vRet & @CRLF & _
		"!@ " & @TAB & "#Error: " & @error & @TAB & "#Extended: " & @extended & @CRLF)

	; Calculates the CRC32 checksum of data from DllStruct
	$vData = 0xFFEEDDAA
	$tStruct = DllStructCreate(' byte String[10]')
	DllStructSetData($tStruct, 'String', $vData) ; or DllStructSetData($tStruct, 1, $vData)
	$vRet = _ComputeCrc32($tStruct) ; Länge der Daten wird automatisch mit DllStructGetSize ermittelt und muss somit nicht angegeben werden!
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   _ComputeCrc32($tStruct)                                       : $vRet --> " & $vRet & @CRLF & _
		"!@ " & @TAB & "#Error: " & @error & @TAB & "#Extended: " & @extended & @CRLF)

	; Calculates the CRC32 checksum of a block of memory
	$vData = 'Dies ist ein Test!'
	$iLen = StringLen($vData)
	$pMem = _MemVirtualAlloc(0, $iLen, $MEM_COMMIT, $PAGE_EXECUTE_READWRITE)
	$tStruct = DllStructCreate('char String['&$iLen&']', $pMem)
	DllStructSetData($tStruct, 1, $vData)
	$vRet = _ComputeCrc32($pMem, $iLen) ; hier muss die Länge der Daten angegeben werden!
	; oder...
;~ 	$vRet = _ComputeCrc32($tStruct)
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   _ComputeCrc32($pMem)                                          : $vRet --> " & $vRet & @CRLF & _
		"!@ " & @TAB & "#Error: " & @error & @TAB & "#Extended: " & @extended & @CRLF)
	_MemVirtualFree($pMem, StringLen($vData), $MEM_DECOMMIT)
EndFunc

